#!/bin/bash
#
# Title: auto maps
# Created By: Tyler "-z-" Mulligan of www.xonotic.org
#
# This plugin provides clever ways for you to link maps from your
# resource pool to your servers.
#

# include the global variables
CD="$(cd "$(dirname $0)"; pwd | sed 's#/extra/plugins##')"
. $CD/xst.inc

# Adds maps to your resource-pool from a remote repository
# map [map...]
add_maps() {
    shift
	if [[ "$@" == "" ]]; then echo "[YOU FAIL] I need the name of your map package(s)"; exit 0; fi
    cd $CD/resource-pool/maps/
    if [[ -f $@ ]]; then
        #wget -i "$CD/resource-pool/maps/$@"    
        while read line; do
            cp -v $(echo $line | sed -e "s#$remote_repository##") $local_repository     
        done < "$CD/resource-pool/maps/$@"
    else
        for map in "$@"; do
            #if no url specified
            #wget ${remote_repository}$map
            wget $map

            cp -v $(echo $map | sed -e "s#$remote_repository##") $local_repository
                        
        done
    fi

	exit 0
}

# Removes maps from your resource-pool
# <map> [map...]
remove_maps() {
	exit 0
}        

# Symlink many maps to many servers
# <map [map...]> <server [server...]>
maps_to_servers() {
    shift
    if [[ "$@" == "" ]]; then echo "[YOU FAIL] I need the name of your map package(s)"; exit 0; fi
    i=0
    for thing in "$@"; do
        if [[ $i == 0 ]]; then
            maps=$thing
        elif [[ $i == 1 ]]; then
            servers=$thing
        fi
        i=$(($i+1))
    done
    # if server doesn't exist, fuck you
    for server in $servers; do
        for map in $maps; do
            ln -sv $CD/resource-pool/maps/$map $CD/servers/$server/
        done
    done
}   

# Symlink many maps to many servers based on type
# <type [type...]> <server [server...]>
types_to_servers() {
	exit 0
} 

not_found() { exit 42; }

if [[ $1 == "--phs" ]]; then # Plugin Help System
    echo "    --pk3-filename-search | --pfs                        Searching through pk3 pacakges for a given string.
    --pk3-mapinfo-search | --pms                        Searching through mapinfos inside pk3 pacakges for a given string."
    exit 0
fi

case $1 in
  --maps-to-servers|--m2s) maps_to_servers "$@";;
  --types-to-servers|--t2s) types_to_servers $@;;
  --add-map|--am) add_maps $@;;
  *) not_found;;
esac

