#!/bin/bash
#
# Title: xst example plugin
# Created By: Tyler "-z-" Mulligan of www.xonotic.org
#
# This script is an example of how to write a plugin for xst
#

# include the global variables
CD="$(cd "$(dirname $0)"; pwd | sed 's#/extra/plugins##')"
. $CD/xst.inc

# Example function
example() {
    echo "[I'm an example] passing a variable (if given): $1"
    echo "Xonotic is located: $XD"
    echo "xst is located: $CD"
    __build_server_array # Build ${SA[@]}
    echo "servers available: ${SA[@]}"
    __build_autoload_server_array # Build ${ASA[@]}
    echo "servers set to autoload: ${ASA[@]}"
}

not_found() { exit 42; }

if [[ $1 == "--phs" ]]; then # Plugin Help System
    echo "    --example | --ex                        Gives you an example of how a plugin works"
    exit 0;
fi

case $1 in
  --example|--ex) example $2;;
  *) not_found;;
esac
